/**
 * Mask used for date and time. Is possible to customize it to display as you wish.
 * @namespace   datetime
 * @memberOf    module:mask
 * @implements  {mask}
 * @property    {String}    [params.format='d9/m9/9999']    -   Defines how the mask should work.
 * @example
  
    //Datetime mask example
    
    //'d' will allow just enters between 0 and 3, 'm' between 0 and 1, 'h' between 0 and 2, 's' between 0 and 5.
    mask: {
        type: "datetime",
        params: {
            format: "d9/m9/9999 h9:s9" 
        }
    }        
 */ 