package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class RelacaoCardapiosPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaRelacaoCardapios = By.xpath("//span[text() = 'Relação de Cardápios']");

    By campoRelatorio = By.xpath("//div[@data-zh-id='139610630039573808914618']//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioSinteticaPorData = By.xpath("//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Relação de Cardápios (Sintética por Data)']");
    By relatorioSinteticaPorServico = By.xpath("//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Relação de Cardápios (Sintética por Serviço)']");
    By relatorioElaboradosPorServico = By.xpath("//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Relação de Cardápios Elaborados por Serviço']");
    By relatorioAnalitcaPorData = By.xpath("//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Relação de Cardápios (Analítica por Data)']");
    By relatorioAnaliticaPorServico = By.xpath("//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Relação de Cardápios (Analítica por Serviço)']");
    By relatorioGeradosAnalitico = By.xpath("//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Relação de Cenários Gerados por serviço (Analítico)']");
    By relatorioGeradosSintetico = By.xpath("//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Relação de Cenários Gerados por serviço (Sintético)']");

    By todasUnidades = By.xpath("//div[@data-zh-id=\"13961063004682836214630\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoUnidade = By.id("NMFILIAL");
    By unidadeDepositoBc129 = By.xpath("//div[@class='body']//span[text() = '9999']");
    //primeira opção que é apresentada no container da unidade, após a seleção da(s) mesma(s) e clicar no botão ok
    By primeiraOptionContainerUnidade = By.xpath("//div[@id=\"NMFILIAL\"]//div[@class=\"zh-options-container\"]/span[1]");

    By todoServicos = By.xpath("//div[@data-zh-id='13961063007731072394637']//div[@class='zh-box mousetrap zh-ripple-effect']");
    By campoServico = By.id("NMSERVICO");
    By servicoSolicitacao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'SOLICITACAO']");
    By servicoDistribuicao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'DISTRIBUICAO']");
    //opções que são apresentadas no container da unidade, após a seleção da(s) mesma(s) e clicar no botão ok
    By primeiraOpcaoContainerServico = By.xpath("//div[@id=\"NMSERVICO\"]//div[@class=\"zh-options-container\"]/span[1]");
    By segundaOpcaoContainerServico = By.xpath("//div[@id=\"NMSERVICO\"]//div[@class=\"zh-options-container\"]/span[2]");

    By botaoOk = By.xpath("//section[@id='popup']//span[text() = 'Ok']");

    By campoDataInicial = By.id("INTERVAL_START");
    By campoDataFinal = By.id("INTERVAL_END");

    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@class='zh-inner-circle']");
    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//span[text() = 'Confirmar']");

    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"139610630024535738284625\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"139610630042219440054632\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioIntervalo = By.xpath("//div[@data-zh-id=\"139610630037864155414639\"]//div[@class=\"zh-validation\"]/span");

    By campoSomenteServicoPrincipal = By.xpath("//label[@for=\"zh-checkbox-IDSERVPRINC\"]//span[@style=\"background-image: none; display: block;\"]");
    By checkSomenteServicoPrincipal = By.id("zh-checkbox-IDSERVPRINC");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Relação de Cardápios");
        click(telaRelacaoCardapios);
    }

    public void selecionarUnidade() {
        click(todasUnidades);
        click(campoUnidade);
        tempo();
        click(unidadeDepositoBc129);
        click(botaoOk);

        String opcaoEncontradaContainerUnidade = getText(primeiraOptionContainerUnidade);
        String opcaoEsperada = "×DEPOSITO BC 129";
        Assert.assertEquals(opcaoEncontradaContainerUnidade, opcaoEsperada, "Verificação da unidade que é apresentada no container da unidade, após a seleção da unidade escolhida");
    }

    public void selecionarTodasUnidades() {
        click(todasUnidades);
    }

    public void selecionarServicos() {
        click(todoServicos);
        click(campoServico);
        click(servicoSolicitacao);
        click(servicoDistribuicao);
        click(botaoOk);

        //nome dos serviços encontrados no container de serviço após a seleção
        String primeiraOpcaoContainerServ = getText(primeiraOpcaoContainerServico);
        String segundaOpcaoContainerServ = getText(segundaOpcaoContainerServico);

        //nome dos serviços que são esperados no container
        String expPrimeiraOpcao = "×SOLICITACAO";
        String expSegundaOpcao = "×DISTRIBUICAO";

        Assert.assertEquals(primeiraOpcaoContainerServ, expPrimeiraOpcao, "Verificação do primeiro serviço que é apresentado no container serviço, após a seleção");
        Assert.assertEquals(segundaOpcaoContainerServ, expSegundaOpcao, "Verificação do segundo serviço que é apresentado no container serviço, após a seleção");
    }

    public void preencherDatas(String dataInicial, String dataFinal) {
        super.preencherDatas(campoDataInicial, campoDataFinal, dataInicial, dataFinal);
    }

    public void geraRelatorio() {
        super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    public void selecionaRelatorio(String nomeDoRelatorio) {
        if (nomeDoRelatorio == "Relação de Cardápios (Sintética por Data)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioSinteticaPorData);
        } else if (nomeDoRelatorio == "Relação de Cardápios (Sintética por Serviço)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioSinteticaPorServico);
        } else if (nomeDoRelatorio == "Relação de Cardápios Elaborados por Serviço") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioElaboradosPorServico);
        } else if (nomeDoRelatorio == "Relação de Cardápios (Analítica por Data)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioAnalitcaPorData);
        } else if (nomeDoRelatorio == "Relação de Cardápios (Analítica por Serviço)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioAnaliticaPorServico);
        } else if (nomeDoRelatorio == "Relação de Cenários Gerados por serviço (Analítico)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioGeradosAnalitico);
        } else if (nomeDoRelatorio == "Relação de Cenários Gerados por serviço (Sintético)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioGeradosSintetico);
        }
    }

    public void verificarCamposObrigatorios() {
        click(todoServicos);
        click(botaoRelatorio);

        //mensagens de campo obrigatório encontrada nos campos
        String unidade = getText(mensagemObrigatorioUnidade);
        String servico = getText(mensagemObrigatorioServico);
        String intervalo = getText(mensagemObrigatorioIntervalo);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo unidade");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo serviço");
        Assert.assertEquals(intervalo, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo intervalo");
    }

    public void verificarCheckBoxSomenteServPrin() {
        boolean checkSomenteServicoPrin = returnIfElementIsSelected(checkSomenteServicoPrincipal);
        Assert.assertEquals(checkSomenteServicoPrin, true, "Verificar se assim que a página carrega o check-box 'somente serviço principal' já está selecionado");

        click(campoSomenteServicoPrincipal);
        checkSomenteServicoPrin = returnIfElementIsSelected(checkSomenteServicoPrincipal);
        Assert.assertEquals(checkSomenteServicoPrin, false, "Verificar se após clicar no campo 'somente serviço principal', o mesmo passa a não estar mais selecionado");
    }

}
