package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ConsumoPorServicoFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.pages.ConsumoPorServicoPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class ConsumoPorServicoTests extends TestBase {

    ConsumoPorServicoPage consumoporservicopage;
    ConsumoPorServicoFlows consumoporservicoflows;
    LoginFlows loginFlows;

    @Test
    public void ConsumoPorServico() throws InterruptedException {
        consumoporservicopage = new ConsumoPorServicoPage();
        consumoporservicoflows = new ConsumoPorServicoFlows();
        loginFlows = new LoginFlows();

        String CDFILIAL = "0002";
        String CDSERVFILI = "00002";
        String CDFILIMPOR = "0003";
        String CDSERVIMPOR = "00002";

        String CDPRODUTO = "101110100100";
        String QTDPRODUTO = "2";
        String NMPRODUTO = "CREOSOTO";

        String CDPRODUTO_2 = "101110100300";
        String QTDPRODUTO_2 = "10";
        String NMPRODUTO_2 = "OLEO DE COPAIBA";


        String QTD = "0";
        String QTDATUAL = "5";

        String msgEsperada = "Não há registros";

        loginFlows.efetuarLogin();
        consumoporservicoflows.navegarConsumoPorServico();
        Thread.sleep(20000);
        consumoporservicoflows.consumoFixo(CDFILIAL, CDSERVFILI);
        consumoporservicoflows.adicionarProduto(CDPRODUTO, QTDPRODUTO, CDPRODUTO_2, QTDPRODUTO_2);
        Assert.assertTrue(consumoporservicoflows.retornaMensagem().contains(NMPRODUTO));
        consumoporservicoflows.adicionarNovoProduto(CDPRODUTO_2, QTDPRODUTO_2);
        Assert.assertTrue(consumoporservicoflows.retornaMensagem_2().contains(NMPRODUTO_2));

        //Adicionando, Editando e Excluindo Exceção
        consumoporservicoflows.cadastraExcecao(CDPRODUTO, QTDPRODUTO);
        consumoporservicoflows.editaExcecao();
        consumoporservicoflows.apagaProdutoExcecao();
        consumoporservicoflows.mensagemExclusao();
        Assert.assertTrue(consumoporservicoflows.mensagemExclusao().contains(msgEsperada));

        //Dia Sem Consumo
        consumoporservicoflows.cadastraDiaSemConsumo();
        consumoporservicoflows.edicaoDiaSemConsumo();
        consumoporservicoflows.apagaDiaSemConsumo();

        //Alterar/Excluir Consumo Dia
        consumoporservicoflows.alterarConsumoDia();
        consumoporservicoflows.apagarConsumo();
        Assert.assertTrue(consumoporservicoflows.mensagemExclusao().contains(msgEsperada));


        //Consumo Per Capita
        consumoporservicoflows.adicionaConsumoPerCapita();
        consumoporservicoflows.insereProdutoPerCapita(CDPRODUTO, QTDPRODUTO, CDPRODUTO_2, QTDPRODUTO_2);
        consumoporservicoflows.informaExcecaoPerCapita(CDPRODUTO, QTD, QTDPRODUTO_2);
        consumoporservicoflows.alteracaoExclusaoPerCapita(QTD, QTDATUAL);
        consumoporservicoflows.cadastraDiaSemConsumo();
        consumoporservicoflows.edicaoDiaSemConsumo();
        consumoporservicoflows.apagaDiaSemConsumo();
        consumoporservicoflows.alteraConsumoPerCapita();
        consumoporservicoflows.apagarConsumo();
        Assert.assertTrue(consumoporservicoflows.mensagemExclusao().contains(msgEsperada));

        //Importação de Consumo
        consumoporservicoflows.importaConsumo(CDFILIMPOR, CDSERVIMPOR);

        //Exporta Consumo
        consumoporservicoflows.exportarConsumo();

        //Substituir Produto
        consumoporservicoflows.substituirProduto();
    }

    @Test
    public void acoesAbaExcecao(){
    consumoporservicopage = new ConsumoPorServicoPage();
    consumoporservicoflows = new ConsumoPorServicoFlows();
    loginFlows = new LoginFlows();
    loginFlows.efetuarLogin();
    consumoporservicoflows.navegarConsumoPorServico();
    consumoporservicoflows.consumoFixo("0002", "00002");
    String CDPRODORIG = "101110201300";
    String CDPRODNOVO = "101110201000";

    //Importar Exceção
    consumoporservicoflows.importarExcecao();

    //Exportar Exceção
    consumoporservicoflows.exportarExcecoesConsumo();
    
    //Substituir Produto Exceção
    consumoporservicoflows.trocarProdutoExcecao(CDPRODNOVO,CDPRODORIG);


    }

}
