package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.RelacaoCardapiosFlows;
import com.javaseleniumtemplate.pages.RelacaoCardapiosPage;
import org.testng.annotations.Test;

public class RelacaoCardapiosTests extends TestBase {

    RelacaoCardapiosPage relacaoCardapiosPage;
    RelacaoCardapiosFlows relacaoCardapiosFlows;
    LoginFlows loginFlows;

    @Test
    public void relatorioSinteticaPorData() {
        emitiRelatorio("Relação de Cardápios (Sintética por Data)");
    }

    @Test
    public void relatorioSinteticaPorServico() {
        emitiRelatorio("Relação de Cardápios (Sintética por Serviço)");
    }

    @Test
    public void relatorioElaboradosPorServico() {
        emitiRelatorio("Relação de Cardápios Elaborados por Serviço");
    }

    @Test
    public void relatorioAnaliticaPorData() {
        emitiRelatorio("Relação de Cardápios (Analítica por Data)");
    }

    @Test
    public void relatorioAnaliticaPorServico() {
        emitiRelatorio("Relação de Cardápios (Analítica por Serviço)");
    }

    @Test
    public void relatorioGeradosAnalitico() {
        emitiRelatorio("Relação de Cenários Gerados por serviço (Analítico)");
    }

    @Test
    public void relatorioGeradosSintetico() {
        emitiRelatorio("Relação de Cenários Gerados por serviço (Sintético)");
    }

    public void emitiRelatorio(String nomeDoRelatorio) {
        relacaoCardapiosPage = new RelacaoCardapiosPage();
        relacaoCardapiosFlows = new RelacaoCardapiosFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/08/2022";
        String dataFinal = "31/10/2022";

        loginFlows.efetuarLogin();
        relacaoCardapiosFlows.navegateRelacaoCardapios();
        relacaoCardapiosPage.selecionaRelatorio(nomeDoRelatorio);
        relacaoCardapiosPage.selecionarTodasUnidades();
        relacaoCardapiosPage.preencherDatas(dataInicial, dataFinal);
        relacaoCardapiosPage.geraRelatorio();
        relacaoCardapiosPage.selecionarUnidade();
        relacaoCardapiosPage.selecionarServicos();
        relacaoCardapiosPage.geraRelatorio();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //vericar os campos obrigatórios
    //verificar o check-box do campo 'Somente Serviço Principal' para ver se o mesmo fica marcado e desmarcado corretamente
    @Test
    public void verificarCamposObrigatorios() {
        relacaoCardapiosPage = new RelacaoCardapiosPage();
        relacaoCardapiosFlows = new RelacaoCardapiosFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        relacaoCardapiosFlows.navegateRelacaoCardapios();
        relacaoCardapiosPage.verificarCamposObrigatorios();
        relacaoCardapiosPage.verificarCheckBoxSomenteServPrin();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

}
